/*@unused@*/static char *sccsid = "dspmailbox.c,  Version 1 Release 6, 01/09/2001";
#define TITLE "MQSeries Services display IE alias queue index"
/******************************************************************/
/*                                                                */
/* (c) Copyright IBM Corp. 2000  All rights reserved.             */
/*                                                                */
/* This sample program is owned by International Business Machines*/
/* Corporation or one of its subsidiaries ("IBM") and is          */
/* copyrighted and licensed, not sold.                            */
/*                                                                */
/* You may copy, modify, and distribute this sample program in    */
/* any form without payment to IBM,  for any purpose including    */
/* developing, using, marketing or distributing programs that     */
/* include or are derivative works of the sample program.         */
/*                                                                */
/* The sample program is provided to you on an "AS IS" basis,     */
/* without warranty of any kind. IBM HEREBY  EXPRESSLY DISCLAIMS  */
/* ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT  */
/* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND      */
/* FITNESS FOR A PARTICULAR PURPOSE.                              */
/* Some jurisdictions do not allow for the exclusion or limitation*/
/* of implied warranties, so the above limitations or exclusions  */
/* may not apply to you. IBM shall not be liable for any damages  */
/* you suffer as a result of using, modifying or distributing the */
/* sample program or its derivatives.                             */
/*                                                                */
/* Each copy of any portion of this sample program or any         */
/* derivative work, must include the above copyright notice and   */
/* disclaimer of warranty.                                        */
/*                                                                */
/******************************************************************/
/*                                                                */
/* Program name: dspmailbox                                       */
/*                                                                */
/* Description: Displays IE alias queue entries                   */
/*                                                                */
/******************************************************************/
/*                                                                */
/* Version 1.0, 24/07/2000, First release NT                      */
/* Version 1.1, 26/07/2000, MQSIE header support added            */
/* Version 1.2, 02/08/2000, First release AIX                     */
/* Version 1.3, 21/08/2000, Cleanup for SupportPac release        */
/* Version 1.4, 23/05/2001, First release OS/400                  */
/* Version 1.5, 23/07/2001, First release Sun Solaris             */
/*                          (no code change)                      */
/* Version 1.6, 01/09/2001, First release Linux86                 */
/*                          (no code change)                      */
/*                                                                */
/* General include files                                          */
#include <stdio.h>                    /* ANSI                     */
#include <stdlib.h>                   /* ANSI                     */
#include <string.h>                   /* ANSI                     */
/* MQSeries product include file                                  */
#include <cmqc.h>                     /* MQSeries product         */
/* Utils include files                                            */
#include "../../../src/file_util.h"   /* string functions         */
#include "../../../src/mq_util.h"     /* MQSeries functions       */
/* MQSeries Services include files                                */
#include "../src/getmailboxindex.h"
/* Program specific include files                                 */
#include "profile.h"
#include "dspmailbox.h"

int main(int argc, char *argv[])
{
   char ProfileName[PATH_MAX];
   char LogText[254];

   PINITFILE   InitFile    = NULL;
   PMQMSGINFO *RecvMsgInfo = NULL;
   
   MQHCONN  Hcon = MQHC_UNUSABLE_HCONN;
   MQLONG   Reason = -1;
   MQLONG   Qdepth = -1;

   strncpy(ProfileName, argc == 1 ? "profile" : argv[1], PATH_MAX);

   if ( (InitFile = ReadProfile(ProfileName)) == NULL )
      return(-1);
   
   if ( (LogInitFile(InitFile, TITLE)) != 0 ) {
		free(InitFile);
      return(-1);
	}

   /***************************************************************/
   /* This program includes an explicit connect (MQCONN), which   */
   /* isn't required on all MQSeries platforms, because it's      */
   /* intended to be portable                                     */
   /***************************************************************/
   if ( (Reason = MQconn(InitFile->logdir, InitFile->qmgr, &Hcon) ) != 0 ) {
      free(InitFile);
      return (int)Reason;
   }

   if ( (RecvMsgInfo = GetMailBoxIndex(InitFile->logdir, Hcon, InitFile->replyq, &Qdepth) ) == NULL ) {
      if (Qdepth < 0) {
         free(InitFile);
         return(-1);
      }
   }
   
   if (Qdepth == 0)
      sprintf(LogText, "There are no messages in %s", InitFile->replyq);
   else {
      DisplayMailBoxIndex(InitFile->logdir, RecvMsgInfo, InitFile->dismqsie, InitFile->logmqsie, Qdepth);
      sprintf(LogText, "Queue depth for %s : %ld message%s", InitFile->replyq, Qdepth, PLURAL(Qdepth) );
   }

   printf("\n%s\n", LogText);
   (void)WriteLogFile(InitFile->logdir, LOG, LogText);      
	/* Return value (type int) ignored */

   FreeMQMSGINFO(RecvMsgInfo, Qdepth);

   /***************************************************************/
   /*   Disconnect from MQM (unless previously connected)         */
   /***************************************************************/
   if (Reason != MQRC_ALREADY_CONNECTED)
      (void)MQdisc(InitFile->logdir, &Hcon);
		/* Return value (type int) ignored */

   free(InitFile);

   return 0;
}
