/*@unused@*/static char *sccsid = "putedi.c,  Version 1 Release 6, 01/09/2001";
/*                                                                   */
/* Version 1.0, 17/03/2000, First release NT                         */
/* Version 1.1, 31/05/2000, Argument reading changed                 */
/* Version 1.2, 02/08/2000, First release AIX                        */
/* Version 1.3, 21/08/2000, Cleanup for SupportPac release           */
/* Version 1.4, 23/05/2001, First release OS/400                     */
/* Version 1.5, 23/07/2001, First release Sun Solaris                */
/*                          (no code change)                         */
/* Version 1.6, 01/09/2001, First release Linux86                    */
/*                          (no code change)                         */
/*                                                                   */
/* General include files                                             */
#include <stdio.h>                    /* ANSI                        */
#include <stdlib.h>                   /* ANSI                        */ 
#include <string.h>                   /* ANSI                        */
/* MQSeries product include file                                     */
#include <cmqc.h>
/* Utils include files                                               */
#include "../../../src/defs.h"        /* general include file        */

int main(int argc, char **argv)
{
   FILE *fp = NULL;

   MQOD     od = {MQOD_DEFAULT};      /* Object Descriptor           */
   MQMD     md = {MQMD_DEFAULT};      /* Message Descriptor          */
   MQPMO   pmo = {MQPMO_DEFAULT};     /* put message options         */
   MQHCONN Hcon = MQHC_UNUSABLE_HCONN;/* connection handle           */
   MQHOBJ  Hobj = MQHO_UNUSABLE_HOBJ; /* object handle               */
   MQLONG  O_options	= 0;             /* MQOPEN options              */
   MQLONG  CompCode	= MQCC_UNKNOWN;  /* completion code             */
   MQLONG  OpenCode	= MQCC_UNKNOWN;  /* MQOPEN completion code      */
   MQLONG  Reason		= MQRC_NONE;     /* reason code                 */
   MQLONG  CReason	= MQRC_NONE;     /* reason code for MQCONN      */
   MQLONG  messlen	= 0;             /* message length              */

   char    buffer[1024];              /* message buffer              */
   
   int RequiredParameters  = 0;
   int i                   = 0;

   bool DebugMode          = FALSE;
	bool ReplyToQMgr  		= FALSE;															/* 22/05/2001 */

   /* Local queuemanager name                                        */
   char QMgrName[MQ_Q_MGR_NAME_LENGTH];  
   /* Target queue name                                              */
   char TQName[MQ_Q_NAME_LENGTH];        
   /* Target queuemanager name                                       */
   char TQMgrName[MQ_Q_MGR_NAME_LENGTH]; 
   /* ReplyTo queue name                                             */
   /* This ReplyTo queue must have an IE alias                       */
   char QName[MQ_Q_NAME_LENGTH];         
   /* ReplyTo manager name optional			                           */			/* 22/05/2001 */
   char ReplyToQMgrName[MQ_Q_MGR_NAME_LENGTH];											/* 22/05/2001 */

   INITSTRARRAY(QMgrName);                        
   INITSTRARRAY(TQName);
   INITSTRARRAY(TQMgrName);                        
   INITSTRARRAY(QName);
	
   for (i = 1; i < argc ; i ++) {
      if (EQUAL(argv[i],"-m")) {
			RequiredParameters++;
         strncpy(QMgrName, argv[i+1], (size_t)MQ_Q_MGR_NAME_LENGTH);
      }
      if (EQUAL(argv[i],"-tq")) {
			RequiredParameters++;
         strncpy(TQName, argv[i+1], (size_t)MQ_Q_NAME_LENGTH);
      }
      if (EQUAL(argv[i],"-tm")) {
			RequiredParameters++;
         strncpy(TQMgrName, argv[i+1], (size_t)MQ_Q_MGR_NAME_LENGTH);
      }
      if (EQUAL(argv[i],"-q")) {
			RequiredParameters++;
         strncpy(QName, argv[i+1], (size_t)MQ_Q_NAME_LENGTH);
		}
      if (EQUAL(argv[i],"-qm")) {															/* 22/05/2001 */
         strncpy(ReplyToQMgrName, argv[i+1], (size_t)MQ_Q_MGR_NAME_LENGTH);	/* 22/05/2001 */
			ReplyToQMgr = TRUE;																	/* 22/05/2001 */
		}																								/* 22/05/2001 */
		if (EQUAL(argv[i],"-debug"))
			DebugMode = TRUE;
	} /* for (i = 1; i < argc ; i ++) */
   
   if (RequiredParameters < 4) {
		printf("Required parameters:\n");
	   printf("%s -m LocalQMgrName -tq TargetQName -tm TargetQMgrName -q ReplyToQName [-qm ReplyToQMgr] [-debug]\n", argv[0]);
      printf("(The ReplyToQName must have an IE Alias)\n");
      exit(EXIT_FAILURE);																		/* 29/07/2001 */
   } /* if (RequiredParameters < 4) */

   if (DebugMode)
      printf("Local QMgrName is <%.*s>\n", (int)MQ_Q_MGR_NAME_LENGTH, QMgrName);

	/******************************************************************/
   /* This program includes an explicit connect (MQCONN), which      */
   /* isn't required on all MQSeries platforms, because it's         */
   /* intended to be portable                                        */
   /******************************************************************/
   MQCONN(QMgrName,                /* queue manager                  */
          &Hcon,                   /* connection handle              */
          &CompCode,               /* completion code                */
          &CReason);               /* reason code                    */

   /* report reason and stop if it failed     */
   if (CompCode == MQCC_FAILED) {
      printf("MQCONN ended with reason code %ld\n", CReason);
      exit( (int)CReason );
   }

   strncpy(od.ObjectName, TQName, (size_t)MQ_Q_NAME_LENGTH);
   strncpy(od.ObjectQMgrName, TQMgrName, (size_t)MQ_Q_MGR_NAME_LENGTH);

   if (DebugMode) {
      printf("Target QName is <%.*s>\n", (int)MQ_Q_NAME_LENGTH, od.ObjectName);
      printf("Target QMgrName is <%.*s>\n", (int)MQ_Q_MGR_NAME_LENGTH, od.ObjectQMgrName);
   }

   /******************************************************************/
   /*   Open target queue                                            */
   /******************************************************************/
   O_options = MQOO_OUTPUT           /* open queue for output        */
             + MQOO_FAIL_IF_QUIESCING;/* but not if MQM stopping     */
   MQOPEN(Hcon,                      /* connection handle            */
          &od,                       /* object descriptor for queue  */
          O_options,                 /* open options                 */
          &Hobj,                     /* object handle                */
          &OpenCode,                 /* MQOPEN completion code       */
          &Reason);                  /* reason code                  */

   /* report reason, if any; stop if failed      */
   if (Reason != MQRC_NONE)
      printf("MQOPEN ended with reason code %ld\n", Reason);

   if (OpenCode == MQCC_FAILED) {
      printf("unable to open queue for output\n");
      exit((int)Reason);
   }

   strcpy(md.ReplyToQ, QName);

	if(ReplyToQMgr)																				/* 22/05/2001 */
		strcpy(md.ReplyToQMgr, ReplyToQMgrName);											/* 22/05/2001 */

   if (DebugMode) {
      printf("ReplyToQ Name is <%.*s>\n", (int)MQ_Q_NAME_LENGTH, md.ReplyToQ);
		if(ReplyToQMgr)																			/* 22/05/2001 */
			printf("ReplyToQMgr Name is <%.*s>\n", (int)MQ_Q_MGR_NAME_LENGTH, md.ReplyToQMgr);/* 22/05/2001 */
	}

   /******************************************************************/
   /*   Read lines from the file and put them to the message queue   */
   /*   Loop until null line or end of file, or there is a failure   */
   /******************************************************************/
   CompCode = OpenCode;        /* use MQOPEN result for initial test */
   fp = stdin;

   memcpy(md.Format,           /* character string format            */
          MQFMT_STRING, (size_t)MQ_FORMAT_LENGTH);

   pmo.Options |= MQPMO_NEW_MSG_ID;

   while (CompCode != MQCC_FAILED) {
      if (fgets(buffer, (int)sizeof(buffer), fp) != NULL) {
         messlen = (MQLONG)strlen(buffer);/* length without null       */
         if (buffer[messlen-1] == '\n') { /* last char is a new-line   */
            buffer[messlen-1]  = '\0';    /* replace new-line with null*/
            --messlen;                    /* reduce buffer length      */
         }
      }
      else messlen = 0;        /* treat EOF same as null line        */

      /***************************************************************/
      /*   Put each buffer to the message queue                      */
      /***************************************************************/
      if (messlen > 0) {
         MQPUT(Hcon,                /* connection handle             */
               Hobj,                /* object handle                 */
               &md,                 /* message descriptor            */
               &pmo,                /* default options (datagram)    */
               messlen,             /* message length                */
               buffer,              /* message buffer                */
               &CompCode,           /* completion code               */
               &Reason);            /* reason code                   */

         /* report reason, if any */
         if (Reason != MQRC_NONE)
            printf("MQPUT ended with reason code %ld\n", Reason);
      }
      else   /* satisfy end condition when empty line is read */
         CompCode = MQCC_FAILED;

   } /* while (CompCode != MQCC_FAILED) */

   /******************************************************************/
   /*   Close the target queue (if it was opened)                    */
   /******************************************************************/
   if (OpenCode != MQCC_FAILED) {
     MQCLOSE(Hcon,                   /* connection handle            */
             &Hobj,                   /* object handle               */
             0,
             &CompCode,               /* completion code             */
             &Reason);                /* reason code                 */

     /* report reason, if any     */
     if (Reason != MQRC_NONE)
       printf("MQCLOSE ended with reason code %ld\n", Reason);
   }

   /******************************************************************/
   /*   Disconnect from MQM if not already connected                 */
   /******************************************************************/
   if (CReason != MQRC_ALREADY_CONNECTED) {
      MQDISC(&Hcon,                   /* connection handle           */
             &CompCode,               /* completion code             */
             &Reason);                /* reason code                 */

     /* report reason, if any     */
      if (Reason != MQRC_NONE)
		   printf("MQDISC ended with reason code %ld\n", Reason);
   }

   /******************************************************************/
   /* END OF PUTEDI                                                  */
   /******************************************************************/
   printf("Sample %s end\n", argv[0]);
   return(0);
}
