#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* Utils include files                                            */
#include "../../../src/str_util.h"    /* string functions         */
/* Functions specific include file                                */
#include "../src/keyword.h"

char *GetKeyword(const char *Keyword, char *s, int len, const char *b, long blength)
{
   char *p    = NULL;
   int i = 0;
   
   if ((p = FindKeyWord(b, blength, Keyword)) == NULL ) {
      for (i = 0 ; i < len ; i++)
         s[i] = '\0';
   }
   else {
      p = p + strlen(Keyword) + 1;
      while ( (i < len) && (*p != ')') ) {
         s[i] = *p;
         i++;
         p++;
      }
      
      while(i < len) {
         s[i] = ' ';
         i++;
      }
   }
   
   return s;
}


char *FindKeyWord(const char *p,const long plength, const char *KeyWord)
{
   char *pTmp = NULL;
   char *pP   = NULL;

   int Offset = 0;

	if ((pTmp = (char *)malloc(sizeof(char) * (1 + plength))) == NULL)
		return NULL;

   memcpy(pTmp, p, (size_t)plength);
   pTmp[plength] = '\0';
   (void)StrUpper(pTmp);
   
   if ((pP = strstr(pTmp, KeyWord)) == NULL )
      return NULL;
   
   Offset = pP - pTmp;

   free(pTmp);

   return(char *)(p + Offset);

}

