#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* MQSeries product include file                                  */
#include <cmqc.h>
/* Utils include files                                            */
#include "../../../src/defs.h"        /* general include file     */
#include "../../../src/str_util.h"    /* string functions         */
#include "../../../src/file_util.h"   /* file functions           */
/* MQSeries Services include files                                */
#include "../src/keyword.h"
#include "../src/mqsie.h"

PMQSIE GetMQSIE(PMQSIE pMqsie, PMQBYTE Buffer, MQLONG BufferLength)
{
   GetKeyword("FROM",       pMqsie->From,       MQSIE_FROMLEN,       Buffer, BufferLength);
   GetKeyword("CLASS",      pMqsie->Class,      MQSIE_CLASSLEN,      Buffer, BufferLength);
   GetKeyword("MSGNAME",    pMqsie->MsgName,    MQSIE_MSGNAMELEN,    Buffer, BufferLength);
   GetKeyword("MSGSEQNO",   pMqsie->MsgSeqNo,   MQSIE_MSGSEQNOLEN,   Buffer, BufferLength);
   GetKeyword("DATATYPE",   pMqsie->DataType,   MQSIE_DATATYPELEN,   Buffer, BufferLength);
   GetKeyword("UNIQUEID",   pMqsie->UniqueId,   MQSIE_UNIQUEIDLEN,   Buffer, BufferLength);
   GetKeyword("CONTROLNUM", pMqsie->ControlNum, MQSIE_CONTROLNUMLEN, Buffer, BufferLength);
   GetKeyword("SEND",       pMqsie->Sender,     MQSIE_SENDERLEN,     Buffer, BufferLength);
   GetKeyword("SENDQUAL",   pMqsie->SendQual,   MQSIE_SENDQUALLEN,   Buffer, BufferLength);
   GetKeyword("RECEIVER",   pMqsie->Receiver,   MQSIE_RECEIVERLEN,   Buffer, BufferLength);
   GetKeyword("RECVQUAL",   pMqsie->RecvQual,   MQSIE_RECVQUALLEN,   Buffer, BufferLength);
   GetKeyword("DATE",       pMqsie->Date,       MQSIE_DATELEN,       Buffer, BufferLength);
   GetKeyword("TIME",       pMqsie->Time,       MQSIE_TIMELEN,       Buffer, BufferLength);
   GetKeyword("RECLEN",     pMqsie->RecLen,     MQSIE_RECLENLEN,     Buffer, BufferLength);
   GetKeyword("RECFM",      pMqsie->RecFm,      MQSIE_RECFMLEN,      Buffer, BufferLength);
   GetKeyword("RECDLM",     pMqsie->Delimited,  MQSIE_DELIMITEDLEN,  Buffer, BufferLength);
   
   return pMqsie;
}


PMQSIE SetMQSIE(PMQSIE pMqsie, char *Keyword, char *KeywordValue)
{
   if (EQUALM("CLASS",       Keyword, strlen("CLASS")))
      memcpy(pMqsie->Class,    KeywordValue, (size_t)MIN(MQSIE_CLASSLEN,     strlen(KeywordValue)) );

   if (EQUALM("DATATYPE",    Keyword, strlen("DATATYPE")))
      memcpy(pMqsie->DataType, KeywordValue, (size_t)MIN(MQSIE_DATATYPELEN,  strlen(KeywordValue)) );

   if (EQUALM("MSGNAME",     Keyword, strlen("MSGNAME")))
      memcpy(pMqsie->Date,     KeywordValue, (size_t)MIN(MQSIE_MSGNAMELEN,   strlen(KeywordValue)) );

   if (EQUALM("MSGSEQNO",    Keyword, strlen("MSGSEQNO")))
      memcpy(pMqsie->Time,     KeywordValue, (size_t)MIN(MQSIE_MSGSEQNOLEN,  strlen(KeywordValue)) );

   if (EQUALM("RETAIN",      Keyword, strlen("RETAIN")))
      memcpy(pMqsie->From,     KeywordValue, (size_t)MIN(MQSIE_RETAINLEN,    strlen(KeywordValue)) );

   if (EQUALM("DESCRIPTION", Keyword, strlen("DESCRIPTION")))
      memcpy(pMqsie->Delimited,KeywordValue, (size_t)MIN(MQSIE_DELIMITEDLEN, strlen(KeywordValue)) );

   if (EQUALM("RECLEN",      Keyword, strlen("RECLEN")))
      memcpy(pMqsie->RecLen,   KeywordValue, (size_t)MIN(MQSIE_RECLENLEN,    strlen(KeywordValue)) );

   if (EQUALM("RECFM",    Keyword, strlen("RECFM")))
      memcpy(pMqsie->RecFm,    KeywordValue, (size_t)MIN(MQSIE_RECFMLEN,     strlen(KeywordValue)) );

   if (EQUALM("RECDLM",      Keyword, strlen("RECDLM")))
      memcpy(pMqsie->Delimited,KeywordValue, (size_t)MIN(MQSIE_DELIMITEDLEN, strlen(KeywordValue)) );

   if (EQUALM("FORCE",       Keyword, strlen("FORCE")))
      memcpy(pMqsie->UniqueId, KeywordValue, (size_t)MIN(MQSIE_UNIQUEIDLEN,  strlen(KeywordValue)) );
   
   return pMqsie;
}


char *CreateMQSIEheader(PMQSIE pMqsie)
{
   char *Header;
   static char Dummy[1024];

   Header = (char *)malloc(sizeof(char) * 10240);
   memset(Header, 0, 10240);

   if(pMqsie->Class[0] != '\0') {
      memcpy(Dummy, pMqsie->Class, MQSIE_CLASSLEN);
      StrTrimI(Dummy, MQSIE_CLASSLEN);
      sprintf(Header, "CLASS(%.*s)", MQSIE_CLASSLEN, Dummy);
   }

   strcat(Header, ";");

   return Header;
}


void DisplayMQSIE(PMQSIE pMqsie)
{
   printf("\tFROM       %.*s\n", MQSIE_FROMLEN,       pMqsie->From);
   printf("\tCLASS      %.*s\n", MQSIE_CLASSLEN,      pMqsie->Class);
   printf("\tMSGNAME    %.*s\n", MQSIE_MSGNAMELEN,    pMqsie->MsgName);
   printf("\tMSGSEQNO   %.*s\n", MQSIE_MSGSEQNOLEN,   pMqsie->MsgSeqNo);
   printf("\tDATATYPE   %.*s\n", MQSIE_DATATYPELEN,   pMqsie->DataType);
   printf("\tUNIQUEID   %.*s\n", MQSIE_UNIQUEIDLEN,   pMqsie->UniqueId);
   printf("\tCONTROLNUM %.*s\n", MQSIE_CONTROLNUMLEN, pMqsie->ControlNum);
   printf("\tSEND       %.*s\n", MQSIE_SENDERLEN,     pMqsie->Sender);
   printf("\tSENDQUAL   %.*s\n", MQSIE_SENDQUALLEN,   pMqsie->SendQual);
   printf("\tRECEIVER   %.*s\n", MQSIE_RECEIVERLEN,   pMqsie->Receiver);
   printf("\tRECVQUAL   %.*s\n", MQSIE_RECVQUALLEN,   pMqsie->RecvQual);
   printf("\tDATE       %.*s\n", MQSIE_DATELEN,       pMqsie->Date);
   printf("\tTIME       %.*s\n", MQSIE_TIMELEN,       pMqsie->Time);
   printf("\tRECLEN     %.*s\n", MQSIE_RECLENLEN,     pMqsie->RecLen);
   printf("\tRECFM      %.*s\n", MQSIE_RECFMLEN,      pMqsie->RecFm);
   printf("\tRECDLM     %.*s\n", MQSIE_DELIMITEDLEN,  pMqsie->Delimited);
}


char LogMQSIE(char *LogDir,PMQSIE pMqsie)
{
   static char LogText[1024];

   sprintf(LogText, "MQSIE ->FROM       %.*s\n" \
                             "\t\t\t\tCLASS      %.*s\n" \
                             "\t\t\t\tMSGNAME    %.*s\n" \
                             "\t\t\t\tMSGSEQNO   %.*s\n" \
                             "\t\t\t\tDATATYPE   %.*s\n" \
                             "\t\t\t\tUNIQUEID   %.*s\n" \
                             "\t\t\t\tCONTROLNUM %.*s\n" \
                             "\t\t\t\tSEND       %.*s\n" \
                             "\t\t\t\tSENDQUAL   %.*s\n" \
                             "\t\t\t\tRECEIVER   %.*s\n" \
                             "\t\t\t\tRECVQUAL   %.*s\n" \
                             "\t\t\t\tDATE       %.*s\n" \
                             "\t\t\t\tTIME       %.*s\n" \
                             "\t\t\t\tRECLEN     %.*s\n" \
                             "\t\t\t\tRECFM      %.*s\n" \
                             "\t\t\t\tRECDLM     %.*s\n", 
                             MQSIE_FROMLEN,       pMqsie->From,
                             MQSIE_CLASSLEN,      pMqsie->Class,
                             MQSIE_MSGNAMELEN,    pMqsie->MsgName,
                             MQSIE_MSGSEQNOLEN,   pMqsie->MsgSeqNo,
                             MQSIE_DATATYPELEN,   pMqsie->DataType,
                             MQSIE_UNIQUEIDLEN,   pMqsie->UniqueId,
                             MQSIE_CONTROLNUMLEN, pMqsie->ControlNum,
                             MQSIE_SENDERLEN,     pMqsie->Sender,
                             MQSIE_SENDQUALLEN,   pMqsie->SendQual,
                             MQSIE_RECEIVERLEN,   pMqsie->Receiver,
                             MQSIE_RECVQUALLEN,   pMqsie->RecvQual,
                             MQSIE_DATELEN,       pMqsie->Date,
                             MQSIE_TIMELEN,       pMqsie->Time,
                             MQSIE_RECLENLEN,     pMqsie->RecLen,
                             MQSIE_RECFMLEN,      pMqsie->RecFm,
                             MQSIE_DELIMITEDLEN,  pMqsie->Delimited );

   return (WriteLogFile(LogDir, LOG, LogText));
}
