#ifndef _H_MQSIE
#define _H_MQSIE

#include <cmqc.h>

/* Format */
#define MQFMT_MQSIE   "MQSIE   "

/* Constants for MQSIE header variable lengths                     */
#define MQSIE_CLASSLEN         8
#define MQSIE_MSGNAMELEN       8
#define MQSIE_MSGSEQNOLEN      5
#define MQSIE_RETAINLEN        2
#define MQSIE_DESCRIPTIONLEN  79
#define MQSIE_RECFMLEN         4
#define MQSIE_RECLENLEN        5
#define MQSIE_DELIMITEDLEN     1
#define MQSIE_FROMLEN         21
#define MQSIE_DATATYPELEN      1
#define MQSIE_DATELEN          6
#define MQSIE_TIMELEN          6
#define MQSIE_UNIQUEIDLEN      8
#define MQSIE_SENDERLEN       35
#define MQSIE_SENDQUALLEN      4
#define MQSIE_RECEIVERLEN     35
#define MQSIE_RECVQUALLEN      4
#define MQSIE_CONTROLNUMLEN   14

/*********************************************************************/
/*  MQSIE Structure -- MQSeries Services IE header                   */
/*********************************************************************/

typedef struct tagMQSIE {
   /* MQSIE header                        */
   char Class[MQSIE_CLASSLEN+1];
   char DataType[MQSIE_DATATYPELEN+1];
   char MsgName[MQSIE_MSGNAMELEN+1];
   char MsgSeqNo[MQSIE_MSGSEQNOLEN+1];
   char Retain[MQSIE_RETAINLEN+1];
   char Description[MQSIE_DESCRIPTIONLEN+1];
   char RecFm[MQSIE_RECFMLEN+1];
   char RecLen[MQSIE_RECLENLEN+1];
   char Delimited[MQSIE_DELIMITEDLEN+1];
   char Sender[MQSIE_SENDERLEN+1];
   char SendQual[MQSIE_SENDQUALLEN+1];
   char Receiver[MQSIE_RECEIVERLEN+1];
   char RecvQual[MQSIE_RECVQUALLEN+1];
   char ControlNum[MQSIE_CONTROLNUMLEN+1];
   char From[MQSIE_FROMLEN+1];
   char Date[MQSIE_DATELEN+1];
   char Time[MQSIE_TIMELEN+1];
   char UniqueId[MQSIE_UNIQUEIDLEN+1];
   char Force;
} MQSIE;

typedef MQSIE * PMQSIE;


PMQSIE GetMQSIE(PMQSIE pMqsie, PMQBYTE Buffer, MQLONG BufferLength);
PMQSIE SetMQSIE(PMQSIE pMqsie, char *Keyword, char *KeywordValue);

char *CreateMQSIEheader(PMQSIE pMqsie);

void DisplayMQSIE(PMQSIE pMqsie);

char LogMQSIE(char *LogDir, PMQSIE pMqsie);

#endif
