#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
/* Utils include files                                            */
#include "defs.h"                     /* general include file     */
/* Functions specific include file                                */
#include "str_util.h"

char *StrRep(char *string, const char *find, const char *replace)
{
   char *tmp      = NULL;
   char *p        = NULL;

   int  i = 0;
   int  j = 0;

   if ( ( p = strstr(string, find) ) == NULL )
      return(string);

   if ( ( tmp = (char *)malloc(sizeof(char) * (strlen(string) + strlen(replace) + 1) ) ) == NULL)
      return(string);

   *p = '\0';
   
   strcpy(tmp, string);
   strcat(tmp, replace);

   j = (int)strlen(string) + (int)strlen(find);
   i = (int)strlen(tmp);
   
   for ( ; string[j] != '\0'; i++, j++)
      tmp[i] = string[j];
   
   tmp[i] = '\0';
   strcpy(string,tmp);
   free(tmp);

   return(string);
}


char *StrNRep(char *string, char *find, char *nreplace, int len)
{
   char *tmp = NULL;
   char *p   = NULL;

   int  i = 0;
   int  j = 0;

   char *replace = NULL;

   if ( ( replace = (char *)malloc(sizeof(char) * (len + 1) ) ) == NULL)
      return(string);

   memcpy(replace, nreplace, (size_t)len);
   replace[len] = '\0';

   if ( ( p = strstr(string, find) ) == NULL ) {
      free(replace);
      return(string);
   }

   if ( ( tmp = (char *)malloc(sizeof(char) * (strlen(string) + strlen(replace) + 1) ) ) == NULL) {
      free(replace);
      return(string);
   }

   *p = '\0';
   
   strcpy(tmp, string);
   strcat(tmp, replace);

   j = (int)strlen(string) + (int)strlen(find);
   i = (int)strlen(tmp);
   
   for ( ; string[j] != '\0'; i++, j++)
      tmp[i] = string[j];
   
   tmp[i] = '\0';
   strcpy(string,tmp);

   free(tmp);
   free(replace);

   return(string);
}


static char *StrRev(char *string)
{
   char s;
   int i = 0;
   int j = (int)strlen(string);
   int k = j / 2;

   j--;

   for(i = 0; i < k ; i++, j--) {
      s = string[j];
      string[j] = string[i];
      string[i] = s;
   }

   return(string);
}


char *itoa(int n, char *string)
{
   int i, t;

   if ( (t = n) < 0 )
      n = - n;

   i = 0;
   do {
      string[i++] = (char)(n % (int)10) + '0';
   } while ( (n /= 10) > 0 );

   if (t < 0)
      string[i++] = '-';

   string[i] = '\0';

   return(StrRev(string));
}


char *StrTrim(char *string)
{
   int i = (int)strlen(string);
   while ( string[--i] == SPACE &&  i > 0 ) string[i] = '\0';
   return (string);
}


char *StrTrimI(char *string, int i)
{
   while ( string[--i] == SPACE &&  i > 0 ) string[i] = '\0';
   return (string);
}


char *StrUpper(char *string)
{
   int i = 0;
   while ( ( string[i] = (char)toupper((int)string[i]) ) != '\0' )
      i++;
   return(string);
}


/*@null@*/char *StrDup(const char *string)
{
   char *s = NULL;

   if ( ( s = (char *)malloc(sizeof(char) * (strlen(string) + 1) ) ) == NULL)
      return(NULL);

   return(strcpy(s,string));
}


char *MonthShortName(int i)
{
    static char *ShortName[] = {
       "   ",
       "Jan", "Feb", "Mar",
       "Apr", "May", "Jun",
       "Jul", "Aug", "Sep",
       "Oct", "Nov", "Dec"
    };
 
    return(i < 1 || i > 12) ? ShortName[0] : ShortName[i];
}
